//GETS A SOURCE FROM AN URL AND RETURNS IT AS A STRING
function getUrlContents(aUrl){
	var	ioService=Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);
	var	scriptableStream=Components
		.classes["@mozilla.org/scriptableinputstream;1"]
		.getService(Components.interfaces.nsIScriptableInputStream);

	var	channel=ioService.newChannel(aUrl, null, null);
	var	input=channel.open();
	scriptableStream.init(input);
	var	str=scriptableStream.read(input.available());
	scriptableStream.close();
	input.close();

	return str;
}

function isGreasemonkeyable(url) {
	var scheme=Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService)
		.extractScheme(url);
	return (
		(scheme == "http" || scheme == "https" || scheme == "file") &&
		!/hiddenWindow\.html$/.test(url)
	);
}

function contentLoad(e) {
	var unsafeWin=e.target.defaultView;
	if (unsafeWin.wrappedJSObject) unsafeWin=unsafeWin.wrappedJSObject;

	var unsafeLoc=new XPCNativeWrapper(unsafeWin, "location").location;
	var href=new XPCNativeWrapper(unsafeLoc, "href").href;

	if (
		isGreasemonkeyable(href)
		&& true
		&& true
	) {
		var script=getUrlContents(
			'chrome://standardogame/content/load/standardogame.js'
		);
		injectScript(script, href, unsafeWin);
	}
}

function injectScript(script, url, unsafeContentWin) {
	var sandbox, script, logger, storage, xmlhttpRequester;
	var safeWin=new XPCNativeWrapper(unsafeContentWin);

	sandbox=new Components.utils.Sandbox(safeWin);

	var storage=new standardogame_ScriptStorage();
	xmlhttpRequester=new standardogame_xmlhttpRequester(
		unsafeContentWin, window//appSvc.hiddenDOMWindow
	);

	sandbox.window=safeWin;
	sandbox.document=sandbox.window.document;
	sandbox.unsafeWindow=unsafeContentWin;

	// patch missing properties on xpcnw
	sandbox.XPathResult=Components.interfaces.nsIDOMXPathResult;

	// add our own APIs
	sandbox.GM_addStyle=function(css) { addStyle(sandbox.document, css) };
	sandbox.GM_setValue=hitch(storage, "setValue");
	sandbox.GM_getValue=hitch(storage, "getValue");
	sandbox.GM_openInTab=hitch(this, "openInTab", unsafeContentWin);
	sandbox.GM_xmlhttpRequest=hitch(
		xmlhttpRequester, "contentStartRequest"
	);
	//unsupported
	sandbox.GM_registerMenuCommand=function(){};
	sandbox.GM_log=function(){};

	sandbox.__proto__=sandbox.window;

	try {
		//alert(script+"OK!!!")
		this.evalInSandbox(
			//"(function(){"+script+"})()",
			script,
			url,
			sandbox);
	} catch (e) {
		var e2=new Error(typeof e=="string" ? e : e.message);
		e2.fileName=script.filename;
		e2.lineNumber=0;
		//GM_logError(e2);
		//alert(e2);
		errdiv = sandbox.document.createElement("DIV");
		errdiv.setAttribute("style","{width: 300px; height: 100px; position: absolute; bottom: 10px; right: 20px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: orangered red red orangered; background-image: url(http://stogame.lepihost.net/standardogamegm/mainproject/error_handling/img/main_error.png);}");
		errdiv.innerHTML="<center>If this error is not <a href='http://stogame.lepihost.net/wiki/index.php?title=FAQ' target='_blank'>Known</a> please <a href='http://stogame.lepihost.net/forum/posting.php?mode=post&f=20' target='_blank'>report</a> it."+
		"<br/>Copy the text below in your message on the board<br/><textarea style='{background: transparent none repeat scroll 0%; overflow-x: hidden; overflow-y: hidden; border: medium none;}' rows='3' cols='10' onClick='this.focus();this.select();' READONLY>"+
		"Error:\n[code]"+e2+"[/code]\n\n"+
		//"File:\n[code]"+e2.fileName+"[/code]\n"+
		//"Line: "+e2.lineNumber+"\n\n"+
		"Url:\n[code]"+url+"[/code]\n\n"+
		"Html:\n[code]"+sandbox.document.documentElement.innerHTML+"[/code]"+
		"</textarea></center>";
		sandbox.document.body.appendChild(errdiv);
	}
}


function evalInSandbox(code, codebase, sandbox) {
	eval(code)
}

function openInTab(unsafeContentWin, url) {
	var unsafeTop = new XPCNativeWrapper(unsafeContentWin, "top").top;

	for (var i = 0; i < this.browserWindows.length; i++) {
		this.browserWindows[i].openInTab(unsafeTop, url);
	}
}

function hitch(obj, meth) {
	if (!obj[meth]) {
		throw "method '" + meth + "' does not exist on object '" + obj + "'";
	}

	var staticArgs = Array.prototype.splice.call(arguments, 2, arguments.length);

	return function() {
		// make a copy of staticArgs (don't modify it because it gets reused for
		// every invocation).
		var args = staticArgs.concat();

		// add all the new arguments
		for (var i = 0; i < arguments.length; i++) {
			args.push(arguments[i]);
		}

		// invoke the original function with the correct this obj and the combined
		// list of static and dynamic arguments.
		
		return obj[meth].apply(obj, args);
	};
}

function addStyle(doc, css) {
	var head, style;
	head = doc.getElementsByTagName('head')[0];
	if (!head) { return; }
	style = doc.createElement('style');
	style.type = 'text/css';
	style.innerHTML = css;
	head.appendChild(style);
}

function onLoad() {
	var	appcontent=window.document.getElementById("appcontent");
	if (appcontent && !appcontent.greased_standardogame_gmCompiler) {
		appcontent.greased_standardogame_gmCompiler=true;
		appcontent.addEventListener("DOMContentLoaded", contentLoad, false);
	}
}

function onUnLoad() {
	//remove now unnecessary listeners
	window.removeEventListener('load', onLoad, false);
	window.removeEventListener('unload', onUnLoad, false);
	window.document.getElementById("appcontent")
		.removeEventListener("DOMContentLoaded", contentLoad, false);
}

function standardogame_ScriptStorage() {
	this.prefMan=new standardogame_PrefManager();
}
standardogame_ScriptStorage.prototype.setValue = function(name, val) {
	this.prefMan.setValue(name, val);
}
standardogame_ScriptStorage.prototype.getValue = function(name, defVal) {
	return this.prefMan.getValue(name, defVal);
}